#include <uC++.h>
#include <uSequence.h>

#define BFX_INTRUSION(S)
#define BFX_EXTRUSION_DECL(S)                    : public uSeqable
#define BFX_EXTRUSION_FOLLOWUP(S)
#define BFX_LIST_HEAD_T(S)                       uSequence<S>
#define BFX_LISTED_ELEM_T(S)                     S*

#define BFX_INSERT_FIRST(S, lst, item)           lst.addHead(&item)
#define BFX_INSERT_LAST(S, lst, item)            lst.addTail(&item)
#define BFX_REMOVE_FIRST(S, lst)                 lst.dropHead()
#define BFX_REMOVE_LAST(S, lst)                  lst.dropTail()
#define BFX_INSERT_BEFORE(S, lst, item, refIter) lst.insertBef(&item, refIter)
#define BFX_INSERT_AFTER(S, lst, item, refIter)  lst.insertAft(refIter, &item)
#define BFX_REMOVE_HERE(S, lst, refIter)         lst.remove(refIter)
#define BFX_INIT(S, lst)

#define BFX_GET_AFTER(S, lst, iter)              lst.succ(iter)
#define BFX_GET_BEFORE(S, lst, iter)             lst.pred(iter)
#define BFX_IS_VALID_POS(S, lst, iter)           ((iter)!=NULL)
#define BFX_DEREF_POS(S, lst, iter)              (iter)
