#include <list>
using namespace std;

#define BFX_INTRUSION(S)
#define BFX_EXTRUSION_DECL(S)
#define BFX_EXTRUSION_FOLLOWUP(S)
#define BFX_LIST_HEAD_T(S)                       list<S*>
#define BFX_LISTED_ELEM_T(S)                     list<S*>::iterator

#define BFX_INSERT_FIRST(S, lst, item)           (lst.push_front(&item), lst.begin())
#define BFX_INSERT_LAST(S, lst, item)            (lst.push_back(&item), BFX_GET_BEFORE(S, lst, lst.end()))
#define BFX_REMOVE_FIRST(S, lst)                 lst.pop_front()
#define BFX_REMOVE_LAST(S, lst)                  lst.pop_back()
#define BFX_INSERT_BEFORE(S, lst, item, refIter) lst.insert(refIter, &item)
#define BFX_INSERT_AFTER(S, lst, item, refIter)  lst.insert(BFX_GET_AFTER(S, lst, refIter), &item)
#define BFX_REMOVE_HERE(S, lst, refIter)         lst.erase(refIter)
#define BFX_INIT(S, lst)

#define BFX_GET_AFTER(S, lst, iter)              ({ list<S*>::iterator answer = (iter); answer++; answer;})
#define BFX_GET_BEFORE(S, lst, iter)             ({ list<S*>::iterator answer = (iter); if ((answer) == lst.begin()) { answer = lst.end(); } else { answer--; } answer; })
#define BFX_IS_VALID_POS(S, lst, iter)           ((iter)!=lst.end())
#define BFX_DEREF_POS(S, lst, iter)              (*iter)
