// stack:    inserts and removes happen at the same end
// insfirst: stack's action happens at the end called "first", "head" or "front"
// inselem:  inserts happen via an element-level operation and removes happen via the api-provided "first"/"head"/"front"

#define BOP_INIT(lst, ui, iters, i) BFX_INSERT_FIRST(B_UserItem, lst, ui[i])

#define BOP_INSERT(lst, ui, iters, i) BFX_INSERT_BEFORE(B_UserItem, lst, ui[i], iters[i-1])
#define BOP_REMOVE(lst, ui, iters, i) BFX_REMOVE_FIRST(B_UserItem, lst)
